Last Comment Bug 302294 - (longlines) [meta] Bugs in rendering of long text strings (e.g. thousands of characters)
(longlines)
: [meta] Bugs in rendering of long text strings (e.g. thousands of characters)
Status: RESOLVED FIXED
: meta
Product: Core
Classification: Components
Component: Graphics (show other bugs)
: Trunk
: PowerPC Mac OS X
: -- normal with 3 votes (vote)
: ---
Assigned To: Nobody; OK to take it and work on it
:
Mentors:
: 326229 (view as bug list)
Depends on: 32334 35229 92193 134504 219717 235344 237085 244018 245255 250334 257660 264405 265551 266140 269050 289299 290311 292667 295769 298472 299512 300421 303546 303819 305264 306529 314308 316874 322920 323385 326176 326188 326191 331086 332881 334814 338251 342922 346234 348202 350993 351605 361612 363061 397891 402831 452559 458882 510688 594637
Blocks:
  Show dependency treegraph
 
Reported: 2005-07-26 20:38 PDT by Jesse Ruderman
Modified: 2011-10-07 09:00 PDT (History)
10 users (show)
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---
Has Regression Range: ---
Has STR: ---


Attachments

Description Jesse Ruderman 2005-07-26 20:38:34 PDT
There are many bugs that occur when Firefox tries to render a large amount of
text (e.g. thousands of characters). Common themes are severe slowdowns, system
freezes, overlapping text, and invisible text.  Some of these issues might
impact security -- overlapping or invisible text could lead to spoofing or at
least users having less information than they should, and system freezes are
considered a security issue even though they're really the fault of the
operating system.
Comment 1 David Baron :dbaron: ⌚️UTC-7 (review requests must explain patch) 2005-07-26 22:25:41 PDT
There's a workaround for many of these in the Xft font code, but not other font
backends.  Probably we should just do something in nsTextFrame -- perhaps even
just creating a maximum text frame size (say, 512 characters, which is I think
what Xft uses) and using next-in-flow linkage for text frames within the same
line.  While it might be nice to want the Gfx API to be pure, it's probably a
lot easier to restrict it and require layout to put things in chunks.  We should
be careful not to separate grapheme clusters between chunks -- i.e., be careful
of both surrogates (representing characters outside of Unicode Plane 0) and
combining characters (which are a bit harder).
Comment 2 Philip Withnall (unavailable) 2006-02-14 09:16:27 PST
*** Bug 326229 has been marked as a duplicate of this bug. ***
Comment 3 Robert O'Callahan (:roc) (Exited; email my personal email if necessary) 2006-05-31 22:31:38 PDT
I'm working on something along the lines of comment #1. But I don't want to change how textframes break, that's rather risky. Instead I'm defining some wrapper functions around the nsIRenderingContext functions that break the text up into chunks of limited size.
Comment 4 Jesse Ruderman 2006-06-03 00:59:03 PDT
Bug 338251 has a patch that fixes most of these issues.
Comment 5 Jesse Ruderman 2006-06-14 22:21:38 PDT
The patch in bug 338251 has been checked in.  Bug 237085 has a patch that fixes some more issues.
Comment 6 Robert O'Callahan (:roc) (Exited; email my personal email if necessary) 2007-11-11 17:01:31 PST
Someone want to retest these bugs on trunk? Most of them should be fixed now.
Comment 7 Benoit Girard (:BenWa) 2011-10-07 09:00:37 PDT
I've been going through the tracked bug here and I can't reproduce any of these issues. Closing this tracking bug.

Note You need to log in before you can comment on or make changes to this bug.